diff --git a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesBase.java
index 85924e0fc..165a70e13 100644
--- a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -17,14 +17,14 @@ import org.jetbrains.annotations.Nullable;
 // Referenced classes of package net.minecraft.src:
 //            Block, IBlockAccess, Material
 
-public abstract class BaseLeavesBlock extends Block
+public abstract class BlockLeavesBase extends Block
 {
     public static final int MASK_DECAY_DATA = 0b0000_1111;
     public static final int NUM_DECAY_BITS = 4;
     public static final int DECAY_FLAG_BIT = 3;
     public static final int PERMANENT_FLAG_BIT = 0;
 
-	public BaseLeavesBlock(String key, String namespaceId, int id, Material material)
+	public BlockLeavesBase(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
         setTicking(true);
@@ -37,7 +37,7 @@ public abstract class BaseLeavesBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
 
         Season season = world.getSeasonManager().getCurrentSeason();
@@ -71,7 +71,7 @@ public abstract class BaseLeavesBlock extends Block
                     for(int dz = -radius; dz <= radius; dz++)
                     {
                         int blockId = world.getBlockId(x + dx, y + dy, z + dz);
-                        if(Block.blocksList[blockId] instanceof BaseLeavesBlock)
+                        if(Block.blocksList[blockId] instanceof BlockLeavesBase)
                         {
                             int meta = world.getBlockMetadata(x + dx, y + dy, z + dz);
                             if (!isPermanent(meta))
@@ -112,12 +112,12 @@ public abstract class BaseLeavesBlock extends Block
                         for(int zOffset = -byte0; zOffset <= byte0; zOffset++)
                         {
                             int k3 = world.getBlockId(x + xOffset, y + yOffset, z + zOffset);
-                            if(Block.blocksList[k3] instanceof LogBlock)
+                            if(Block.blocksList[k3] instanceof BlockLog)
                             {
                                 adjacentTreeBlocks[(xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength)] = 0;
                                 continue;
                             }
-                            if(Block.blocksList[k3] instanceof BaseLeavesBlock)
+                            if(Block.blocksList[k3] instanceof BlockLeavesBase)
                             {
                                 adjacentTreeBlocks[(xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength)] = -2;
                             } else
diff --git a/src/main/java/net/minecraft/core/block/BirchLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesBirch.java
similarity index 71%
rename from src/main/java/net/minecraft/core/block/BirchLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesBirch.java
index a56d3b60b..84281eec2 100644
--- a/src/main/java/net/minecraft/core/block/BirchLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesBirch.java
@@ -3,15 +3,15 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.material.Material;
 
 // Referenced classes of package net.minecraft.src:
-//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            BlockLeavesBase, Material, ColorizerFoliage, IBlockAccess,
 //            WorldChunkManager, World, Block, Player,
 //            ItemStack, Item, ItemShears, StatList, 
 //            Entity
 
-public class BirchLeavesBlock extends BaseLeavesBlock
+public class BlockLeavesBirch extends BlockLeavesBase
 {
 
-	public BirchLeavesBlock(String key, String namespaceId, int id)
+	public BlockLeavesBirch(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.leaves);
     }
diff --git a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesCacao.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesCacao.java
index f6c97c0aa..ae27a6f24 100644
--- a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesCacao.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -18,12 +18,12 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
+public class BlockLeavesCacao extends BlockLeavesBase implements IBonemealable {
 
     public static final int MASK_GROWTH_DATA = 0b1111_0000;
     public static final int MAX_GROWTH_STATE = 4;
     static final int BEAN_GROWTH_RATE = 50;
-    public CacaoLeavesBlock(String key, String namespaceId, int id) {
+    public BlockLeavesCacao(String key, String namespaceId, int id) {
         super(key, namespaceId, id, Material.leaves);
         setTicking(true);
     }
@@ -40,7 +40,7 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(this) };
 
@@ -50,7 +50,7 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
             return new ItemStack[] { new ItemStack(Items.DYE, MathHelper.ceil((double) growthRate / 2), DyeColor.BROWN.itemMeta)};
         }
 
-        return super.getBreakResult(world, dropCause, meta, blockEntity);
+        return super.getBreakResult(world, dropCause, meta, tileEntity);
     }
 
     @Override
@@ -84,7 +84,7 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
     }
 
     @Override
-    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+    public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
         harvest(world, x, y, z, null);
     }
 
diff --git a/src/main/java/net/minecraft/core/block/CherryLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesCherry.java
similarity index 83%
rename from src/main/java/net/minecraft/core/block/CherryLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesCherry.java
index f5b8a293a..57e707f5e 100644
--- a/src/main/java/net/minecraft/core/block/CherryLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesCherry.java
@@ -7,15 +7,15 @@ import net.minecraft.core.world.season.Seasons;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            BlockLeavesBase, Material, ColorizerFoliage, IBlockAccess,
 //            WorldChunkManager, World, Block, Player,
 //            ItemStack, Item, ItemShears, StatList, 
 //            Entity
 
-public class CherryLeavesBlock extends BaseLeavesBlock
+public class BlockLeavesCherry extends BlockLeavesBase
 {
 
-	public CherryLeavesBlock(String key, String namespaceId, int id)
+	public BlockLeavesCherry(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.leaves);
     }
diff --git a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
index 332cbfe1e..6d991b53d 100644
--- a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
@@ -15,16 +15,16 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBonemealable
+public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBonemealable
 {
     public static final int MASK_GROWTH_DATA = 0b1111_0000;
     public static final int MAX_GROWTH_STATE = 1;
-	public FloweringCherryLeavesBlock(String key, String namespaceId, int id) {
+	public BlockLeavesCherryFlowering(String key, String namespaceId, int id) {
         super(key, namespaceId, id);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         int growthRate = getGrowthRate(meta);
         if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(this) };
@@ -68,7 +68,7 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
     }
 
     @Override
-    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+    public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
         harvest(world, x, y, z, null);
     }
 
diff --git a/src/main/java/net/minecraft/core/block/EucalyptusLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/EucalyptusLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
index dd0e431a8..ace4ab8d5 100644
--- a/src/main/java/net/minecraft/core/block/EucalyptusLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
@@ -6,15 +6,15 @@ import net.minecraft.core.block.material.Material;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            BlockLeavesBase, Material, ColorizerFoliage, IBlockAccess,
 //            WorldChunkManager, World, Block, Player,
 //            ItemStack, Item, ItemShears, StatList, 
 //            Entity
 
-public class EucalyptusLeavesBlock extends BaseLeavesBlock
+public class BlockLeavesEucalyptus extends BlockLeavesBase
 {
 
-	public EucalyptusLeavesBlock(String key, String namespaceId, int id)
+	public BlockLeavesEucalyptus(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.leaves);
     }
diff --git a/src/main/java/net/minecraft/core/block/OakLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
similarity index 89%
rename from src/main/java/net/minecraft/core/block/OakLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesOak.java
index 12b58a7dd..5c41efdbf 100644
--- a/src/main/java/net/minecraft/core/block/OakLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
@@ -7,14 +7,14 @@ import net.minecraft.core.world.wind.WindProvider;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            BlockLeavesBase, Material, ColorizerFoliage, IBlockAccess,
 //            WorldChunkManager, World, Block, Player,
 //            ItemStack, Item, ItemShears, StatList, 
 //            Entity
 
-public class OakLeavesBlock extends BaseLeavesBlock
+public class BlockLeavesOak extends BlockLeavesBase
 {
-	public OakLeavesBlock(String key, String namespaceId, int id)
+	public BlockLeavesOak(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.leaves);
     }
@@ -36,7 +36,7 @@ public class OakLeavesBlock extends BaseLeavesBlock
                 }
                 else if (world.getBlockId(x, y + q, z) == Blocks.LAYER_LEAVES_OAK.id)
                 {
-                    ((LeavesLayerBlock) Blocks.LAYER_LEAVES_OAK).accumulate(world, x, y + q, z);
+                    ((BlockLayerLeaves) Blocks.LAYER_LEAVES_OAK).accumulate(world, x, y + q, z);
                     break;
                 }
             }
diff --git a/src/main/java/net/minecraft/core/block/PalmLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesPalm.java
similarity index 65%
rename from src/main/java/net/minecraft/core/block/PalmLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesPalm.java
index 6738b2313..713032a33 100644
--- a/src/main/java/net/minecraft/core/block/PalmLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesPalm.java
@@ -2,9 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 
-public class PalmLeavesBlock extends BaseLeavesBlock {
+public class BlockLeavesPalm extends BlockLeavesBase {
 
-	public PalmLeavesBlock(String key, String namespaceId, int id) {
+	public BlockLeavesPalm(String key, String namespaceId, int id) {
 		super(key, namespaceId, id, Material.leaves);
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/PineLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesPine.java
similarity index 77%
rename from src/main/java/net/minecraft/core/block/PineLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesPine.java
index 15740284c..59b825eed 100644
--- a/src/main/java/net/minecraft/core/block/PineLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesPine.java
@@ -1,27 +1,27 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
 // Referenced classes of package net.minecraft.src:
-//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            BlockLeavesBase, Material, ColorizerFoliage, IBlockAccess,
 //            WorldChunkManager, World, Block, Player,
 //            ItemStack, Item, ItemShears, StatList, 
 //            Entity
 
-public class PineLeavesBlock extends BaseLeavesBlock
+public class BlockLeavesPine extends BlockLeavesBase
 {
 
-	public PineLeavesBlock(String key, String namespaceId, int id)
+	public BlockLeavesPine(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.leaves);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(this) };
 
diff --git a/src/main/java/net/minecraft/core/block/RetroLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesRetro.java
similarity index 68%
rename from src/main/java/net/minecraft/core/block/RetroLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesRetro.java
index 8f43daa80..87649b35a 100644
--- a/src/main/java/net/minecraft/core/block/RetroLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesRetro.java
@@ -2,9 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 
-public class RetroLeavesBlock extends BaseLeavesBlock
+public class BlockLeavesRetro extends BlockLeavesBase
 {
-	public RetroLeavesBlock(String key, String namespaceId, int id)
+	public BlockLeavesRetro(String key, String namespaceId, int id)
 	{
         super(key, namespaceId, id, Material.leaves);
 	}
diff --git a/src/main/java/net/minecraft/core/block/ShrubLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/ShrubLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
index 3632ad986..25a65f5f3 100644
--- a/src/main/java/net/minecraft/core/block/ShrubLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
@@ -6,15 +6,15 @@ import net.minecraft.core.block.material.Material;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            BlockLeavesBase, Material, ColorizerFoliage, IBlockAccess,
 //            WorldChunkManager, World, Block, Player,
 //            ItemStack, Item, ItemShears, StatList,
 //            Entity
 
-public class ShrubLeavesBlock extends BaseLeavesBlock
+public class BlockLeavesShrub extends BlockLeavesBase
 {
 
-	public ShrubLeavesBlock(String key, String namespaceId, int id)
+	public BlockLeavesShrub(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.leaves);
     }
diff --git a/src/main/java/net/minecraft/core/block/ThornLeavesBlock.java b/src/main/java/net/minecraft/core/block/BlockLeavesThorn.java
similarity index 68%
rename from src/main/java/net/minecraft/core/block/ThornLeavesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLeavesThorn.java
index 4ca86074d..992442b61 100644
--- a/src/main/java/net/minecraft/core/block/ThornLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesThorn.java
@@ -2,9 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 
-public class ThornLeavesBlock extends BaseLeavesBlock
+public class BlockLeavesThorn extends BlockLeavesBase
 {
-    public ThornLeavesBlock(String key, String namespaceId, int id)
+    public BlockLeavesThorn(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.leaves);
     }
diff --git a/src/main/java/net/minecraft/core/block/LeverBlock.java b/src/main/java/net/minecraft/core/block/BlockLever.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/LeverBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLever.java
index 62e0a9e9b..7023bdab9 100644
--- a/src/main/java/net/minecraft/core/block/LeverBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLever.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -17,7 +17,7 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class LeverBlock extends Block
+public class BlockLever extends Block
 {
     public static final int MASK_POWERED = 0b0001_0000;
     public static final int MASK_ROTATION = 0b0000_1111;
@@ -30,7 +30,7 @@ public class LeverBlock extends Block
     public static final int ROTATION_BOTTOM_NS = 7;
     public static final int ROTATION_BOTTOM_WE = 8;
 
-	public LeverBlock(String key, String namespaceId, int id)
+	public BlockLever(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.decoration);
     }
@@ -282,7 +282,7 @@ public class LeverBlock extends Block
     }
 
     @Override
-    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+    public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
         flip(world, x, y, z, null);
     }
 
diff --git a/src/main/java/net/minecraft/core/block/LogBlock.java b/src/main/java/net/minecraft/core/block/BlockLog.java
similarity index 77%
rename from src/main/java/net/minecraft/core/block/LogBlock.java
rename to src/main/java/net/minecraft/core/block/BlockLog.java
index 863d86464..9d81135a2 100644
--- a/src/main/java/net/minecraft/core/block/LogBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockLog.java
@@ -3,10 +3,10 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class LogBlock extends AxisAlignedBlock
+public class BlockLog extends BlockAxisAligned
 {
 
-	public LogBlock(String key, String namespaceId, int id)
+	public BlockLog(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.wood);
     }
@@ -25,14 +25,14 @@ public class LogBlock extends AxisAlignedBlock
                     for(int _z = -r; _z <= r; _z++)
                     {
                         int l1 = world.getBlockId(x + _x, y + _y, z + _z);
-                        if(!(Block.blocksList[l1] instanceof BaseLeavesBlock))
+                        if(!(Block.blocksList[l1] instanceof BlockLeavesBase))
                         {
                             continue;
                         }
                         int leavesMeta = world.getBlockMetadata(x + _x, y + _y, z + _z);
-                        if(!BaseLeavesBlock.isPermanent(leavesMeta))
+                        if(!BlockLeavesBase.isPermanent(leavesMeta))
                         {
-                            world.setBlockMetadata(x + _x, y + _y, z + _z, BaseLeavesBlock.setDecaying(leavesMeta, true));
+                            world.setBlockMetadata(x + _x, y + _y, z + _z, BlockLeavesBase.setDecaying(leavesMeta, true));
                         }
                     }
 
diff --git a/src/main/java/net/minecraft/core/block/MeshBlock.java b/src/main/java/net/minecraft/core/block/BlockMesh.java
similarity index 74%
rename from src/main/java/net/minecraft/core/block/MeshBlock.java
rename to src/main/java/net/minecraft/core/block/BlockMesh.java
index b7b0cf44c..41b2e5072 100644
--- a/src/main/java/net/minecraft/core/block/MeshBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockMesh.java
@@ -5,13 +5,13 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.world.World;
 
-public class MeshBlock extends TransparentBlock
+public class BlockMesh extends BlockTransparent
 {
 
-    public MeshBlock(String key, String namespaceId, int id)
+    public BlockMesh(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.metal);
     }
@@ -30,6 +30,6 @@ public class MeshBlock extends TransparentBlock
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        return !(entity instanceof ItemEntity);
+        return !(entity instanceof EntityItem);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/GoldMeshBlock.java b/src/main/java/net/minecraft/core/block/BlockMeshGold.java
similarity index 67%
rename from src/main/java/net/minecraft/core/block/GoldMeshBlock.java
rename to src/main/java/net/minecraft/core/block/BlockMeshGold.java
index 4ab8cd9c2..70f09e2b5 100644
--- a/src/main/java/net/minecraft/core/block/GoldMeshBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockMeshGold.java
@@ -1,23 +1,23 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.GoldMeshBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityMeshGold;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class GoldMeshBlock extends EntityBlock {
-    public GoldMeshBlock(String key, String namespaceId, int id) {
+public class BlockMeshGold extends BlockTileEntity {
+    public BlockMeshGold(String key, String namespaceId, int id) {
         super(key, namespaceId, id, Material.metal);
     }
 
     @Override
-    protected BlockEntity getNewBlockEntity() {
-        return new GoldMeshBlockEntity();
+    protected TileEntity getNewBlockEntity() {
+        return new TileEntityMeshGold();
     }
     @Override
     public boolean isSolidRender()
@@ -38,7 +38,7 @@ public class GoldMeshBlock extends EntityBlock {
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
-        GoldMeshBlockEntity meshGold = (GoldMeshBlockEntity) world.getBlockEntity(x, y, z);
+        TileEntityMeshGold meshGold = (TileEntityMeshGold) world.getBlockEntity(x, y, z);
         ItemStack heldItem = player.getHeldItem();
         boolean flag = meshGold.setFilterItem(player, heldItem);
         if(heldItem != null && heldItem.stackSize <= 0)
@@ -50,11 +50,11 @@ public class GoldMeshBlock extends EntityBlock {
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        if (entity instanceof ItemEntity){
-            GoldMeshBlockEntity mesh = (GoldMeshBlockEntity) world.getBlockEntity(x, y, z);
+        if (entity instanceof EntityItem){
+            TileEntityMeshGold mesh = (TileEntityMeshGold) world.getBlockEntity(x, y, z);
             if (mesh.filterItem == null) return true;
 
-            ItemStack entityStack = ((ItemEntity) entity).item;
+            ItemStack entityStack = ((EntityItem) entity).item;
             return !entityStack.isItemEqual(mesh.filterItem);
         }
         return true;
diff --git a/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java b/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
rename to src/main/java/net/minecraft/core/block/BlockMobSpawner.java
index 851902b96..f3ca1073d 100644
--- a/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
@@ -1,11 +1,10 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
-import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -15,10 +14,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public class MobSpawnerBlock extends EntityBlock
+public class BlockMobSpawner extends BlockTileEntity
 {
 
-	public MobSpawnerBlock(String key, String namespaceId, int id)
+	public BlockMobSpawner(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.stone);
     }
@@ -34,26 +33,26 @@ public class MobSpawnerBlock extends EntityBlock
     }
 
     @Override
-	public BlockEntity getNewBlockEntity()
+	public TileEntity getNewBlockEntity()
     {
-        return new MobSpawnerBlockEntity();
+        return new TileEntityMobSpawner();
     }
 
     @Override
 	public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-    	MobSpawnerBlockEntity tileEntity = (MobSpawnerBlockEntity) world.getBlockEntity(x, y, z);
+    	TileEntityMobSpawner tileEntity = (TileEntityMobSpawner) world.getBlockEntity(x, y, z);
     	tileEntity.setMobId("none");
     }
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        return !(entity instanceof ItemEntity);
+        return !(entity instanceof EntityItem);
     }
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
         if (!world.isClientSide) {
-            MobSpawnerBlockEntity tileEntityMobSpawner = (MobSpawnerBlockEntity) world.getBlockEntity(x, y, z);
+            TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) world.getBlockEntity(x, y, z);
             if (tileEntityMobSpawner == null) return;
             int amountToDrop = world.rand.nextInt(10) + 10;
             label0:
@@ -100,7 +99,7 @@ public class MobSpawnerBlock extends EntityBlock
                             i1 = itemstack.stackSize;
                         }
                         itemstack.stackSize -= i1;
-                        ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                        EntityItem entityitem = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
                         float f3 = 0.05F;
                         entityitem.xd = (float) world.rand.nextGaussian() * f3;
                         entityitem.yd = (float) world.rand.nextGaussian() * f3 + 0.2F;
@@ -114,7 +113,7 @@ public class MobSpawnerBlock extends EntityBlock
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         if (dropCause == EnumDropCause.SILK_TOUCH)
         {
